commit 2b56c5a4c5c1c8cb3cb1fa6b7740b7f8f03bb8d3
Author: Marc Dequènes (Duck) <Duck@DuckCorp.org>
Date:   Mon Oct 12 23:14:25 2009 +0200

    [evol] improve config #3 (move non-framework translations in config dir)

diff --git a/conf/ldap_shadows/translations/en.yml b/conf/ldap_shadows/translations/en.yml
new file mode 100644
index 0000000..4521b30
--- /dev/null
+++ b/conf/ldap_shadows/translations/en.yml
@@ -0,0 +1,69 @@
+---
+en:
+  objects:
+    bot: "Bot"
+    domain: "Domain"
+    entity: "Entity"
+    group: "Group"
+    individual: "Individual"
+    secondary_account: "Secondary Account"
+    systemAccount: "System Account"
+    unit: "Unit"
+  attribute_types:
+    allowGlobalDirectory: "Disclose Own Contact Information in GLobal Directory"
+    cn: "Full Name"
+    createTimestamp: "Item creation time"
+    creatorsName: "Item Creator"
+    birthday: "Birthday"
+    birthlocation: "Birth Location"
+    description: "Description"
+    entryUUID: "Item UUID"
+    foundingDate: "Founding Date"
+    gecos: "GECOS"
+    gidNumber: "Primary Group (numeric)"
+    givenName: "FirstName"
+    homeDirectory: "Home Directory"
+    homePostalAddress: "Home Postal Address"
+    host: "Shell Allowed Hosts"
+    jid: "Jabber ID"
+    jpegPhoto: "Photo"
+    keyFingerPrint: "GPG/PGP Key Fingerprint"
+    labeledURI: "Web Site"
+    loginShell: "Shell Interpreter"
+    mail: "eMail address(es)"
+    mailForward: "eMail Forward Adress(es)"
+    mailQuota: "Maximum Mailbox Size"
+    manager: "Manager(s)"
+    mobile: "Mobile Phone"
+    modifiersName: "Item Last Modifier"
+    modifyTimestamp: "Item Last Modification Time"
+    occupation: "Job / Studies"
+    o: "Organization(s)"
+    structuralObjectClass: "Item Structural Classes"
+    owner: "Owner(s)"
+    preferredLanguage: "Language Preference"
+    sn: "Surname"
+    sshAuthKey: "SSH Public Key(s)"
+    uid: "Identifier (Login)"
+    uidNumber: "Identifier (numeric)"
+    uniqueAbbreviation: "Unique Abbreviation"
+    uniqueMember: "Group member"
+    userPassword: "Password"
+    webVirtualHost: "Hosted Web Sites"
+  relations:
+    primaryGroup: "Primary Group"
+    secondaryGroups: "Secondary Groups"
+    individualsPrimaryMembers: "Primary Member(s) Individual(s)"
+    botsPrimaryMembers: "Primary Member(s) Bot(s)"
+    individualsSecondaryMembers: "Secondary Member(s) Individual(s)"
+    botsSecondaryMembers: "Secondary Member(s) Bot(s)"
+    foundersIndividuals: "Founder(s) Individual(s)"
+    foundersEntities: "Founder(s) Entity(ies)"
+  aspects:
+    fs: "FileSystem Account"
+    ftp: "FTP Account"
+    jabber: "Jabber Account"
+    mail: "eMail Account"
+    primary: "Primary Account"
+    shell: "Shell Account"
+    web: "Web Account"
diff --git a/data/ldap_shadows/en.yml b/data/ldap_shadows/en.yml
deleted file mode 100644
index 4521b30..0000000
--- a/data/ldap_shadows/en.yml
+++ /dev/null
@@ -1,69 +0,0 @@
----
-en:
-  objects:
-    bot: "Bot"
-    domain: "Domain"
-    entity: "Entity"
-    group: "Group"
-    individual: "Individual"
-    secondary_account: "Secondary Account"
-    systemAccount: "System Account"
-    unit: "Unit"
-  attribute_types:
-    allowGlobalDirectory: "Disclose Own Contact Information in GLobal Directory"
-    cn: "Full Name"
-    createTimestamp: "Item creation time"
-    creatorsName: "Item Creator"
-    birthday: "Birthday"
-    birthlocation: "Birth Location"
-    description: "Description"
-    entryUUID: "Item UUID"
-    foundingDate: "Founding Date"
-    gecos: "GECOS"
-    gidNumber: "Primary Group (numeric)"
-    givenName: "FirstName"
-    homeDirectory: "Home Directory"
-    homePostalAddress: "Home Postal Address"
-    host: "Shell Allowed Hosts"
-    jid: "Jabber ID"
-    jpegPhoto: "Photo"
-    keyFingerPrint: "GPG/PGP Key Fingerprint"
-    labeledURI: "Web Site"
-    loginShell: "Shell Interpreter"
-    mail: "eMail address(es)"
-    mailForward: "eMail Forward Adress(es)"
-    mailQuota: "Maximum Mailbox Size"
-    manager: "Manager(s)"
-    mobile: "Mobile Phone"
-    modifiersName: "Item Last Modifier"
-    modifyTimestamp: "Item Last Modification Time"
-    occupation: "Job / Studies"
-    o: "Organization(s)"
-    structuralObjectClass: "Item Structural Classes"
-    owner: "Owner(s)"
-    preferredLanguage: "Language Preference"
-    sn: "Surname"
-    sshAuthKey: "SSH Public Key(s)"
-    uid: "Identifier (Login)"
-    uidNumber: "Identifier (numeric)"
-    uniqueAbbreviation: "Unique Abbreviation"
-    uniqueMember: "Group member"
-    userPassword: "Password"
-    webVirtualHost: "Hosted Web Sites"
-  relations:
-    primaryGroup: "Primary Group"
-    secondaryGroups: "Secondary Groups"
-    individualsPrimaryMembers: "Primary Member(s) Individual(s)"
-    botsPrimaryMembers: "Primary Member(s) Bot(s)"
-    individualsSecondaryMembers: "Secondary Member(s) Individual(s)"
-    botsSecondaryMembers: "Secondary Member(s) Bot(s)"
-    foundersIndividuals: "Founder(s) Individual(s)"
-    foundersEntities: "Founder(s) Entity(ies)"
-  aspects:
-    fs: "FileSystem Account"
-    ftp: "FTP Account"
-    jabber: "Jabber Account"
-    mail: "eMail Account"
-    primary: "Primary Account"
-    shell: "Shell Account"
-    web: "Web Account"
diff --git a/lib/ldap_shadows/display_utils.rb b/lib/ldap_shadows/display_utils.rb
index e7ef55c..251bc94 100644
--- a/lib/ldap_shadows/display_utils.rb
+++ b/lib/ldap_shadows/display_utils.rb
@@ -21,7 +21,7 @@ require 'active_support'
 
 module LdapShadows
   module Translator
-    I18n.load_path += Dir[File.join(Config::DATA_DIR, "*.yml")]
+    I18n.load_path += Dir[File.join(Config::CFG_DIR, "translations", "**", "*.yml")]
     I18n.default_locale = :en
 
     def self.translate_object_name(obj_hdl)